/*
robo
*/
freeslot("MT_FLYINGROBO","S_FROBO1","S_FROBO2","SPR_BUZ2")

mobjinfo[MT_FLYINGROBO] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_FROBO1,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOCLIP|MF_NOGRAVITY|MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
}

states[S_FROBO1] = {SPR_BUZZ, FF_FULLBRIGHT|A, 4, nil, 0, 0, S_FROBO2}
states[S_FROBO2] = {SPR_BUZZ, FF_FULLBRIGHT|B, 4, nil, 0, 0, S_FROBO1}

addHook("PlayerSpawn", function(p)
	if p and p.valid and p.mo.skin == "jett" then
		p.canvhelp = 1
		if not (p.robotplayer and p.robotplayer.valid)
		    p.robotplayer = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + p.mo.height, MT_FLYINGROBO)
		    p.robotplayer.target = p.mo
			p.robotplayer.colorized = true
			p.robotplayer.color = robot.color
		end
	end
end)


addHook("MobjThinker", function(robot)
	if robot.robofloat == nil
		robot.robofloat = 0
	end
	if robot.valid
		robot.robofloat = $ + 1
		robot.colorized = true
		robot.color = robot.target.player.mo.color
	end
	if robot.robofloat == 10
		robot.robofloat = 0
	end
	if robot.cooldown == nil
		robot.cooldown = 0
	end
	if not (robot.cooldown == 0)
		robot.cooldown = $ - 1
	end
	if robot.robofloat == 1
		A_CapeChase(robot, FRACUNIT*44, 0)
	elseif robot.robofloat == 2
		A_CapeChase(robot, FRACUNIT*46, 0)
	elseif robot.robofloat == 3
		A_CapeChase(robot, FRACUNIT*48, 0)
	elseif robot.robofloat == 4
		A_CapeChase(robot, FRACUNIT*50, 0)
	elseif robot.robofloat == 5
		A_CapeChase(robot, FRACUNIT*52, 0)
	elseif robot.robofloat == 6
		A_CapeChase(robot, FRACUNIT*50, 0)
	elseif robot.robofloat == 7
		A_CapeChase(robot, FRACUNIT*48, 0)
	elseif robot.robofloat == 8
		A_CapeChase(robot, FRACUNIT*46, 0)
	elseif robot.robofloat == 9
		A_CapeChase(robot, FRACUNIT*44, 0)
	elseif robot.robofloat == 10
		A_CapeChase(robot, FRACUNIT*42, 0)
	else
		A_CapeChase(robot, FRACUNIT*40, 0)
	end
	if robot.valid
		local newtarget = P_LookForEnemies(robot.target.player, true, true)
		if newtarget and newtarget.valid and newtarget.health and not newtarget.player
		and robot.cooldown == 0
			local rocket = P_SpawnMobj(robot.x, robot.y, robot.z, MT_TORPEDO)
			rocket.target = robot.target
			rocket.colorized = true
			rocket.color = robot.target.player.mo.color
			rocket.homing = true
			P_InstaThrust(rocket, rocket.angle, 70*FRACUNIT)
			robot.cooldown = 40
		end
	end
	if not (robot.target)
	    P_RemoveMobj(robot)
	end
	if (robot.target) and not (robot.target.player.mo.skin == "jett")
	    P_RemoveMobj(robot)
	end
end, MT_FLYINGROBO)

addHook("MobjThinker", function(rocket)
	if rocket.homing == nil
		rocket.homing = false
	end
	if (rocket.target) and (rocket.target.player)
		local rocketseek = P_LookForEnemies(rocket.target.player, false, true)
		if rocketseek
		and rocket.homing == true
			rocket.flags2 = $|MF2_DONTDRAW
			P_SpawnPointMissile(rocket.target, rocketseek.x, rocketseek.y, rocketseek.z, MT_TORPEDO, rocket.x, rocket.y, rocket.z)
			P_RemoveMobj(rocket)
			return true
		end
	end
end, MT_TORPEDO)

addHook("PlayerThink", function(player)
	if player.divingreal == nil
		player.divingreal = false
	end
	if player.divingreal == true
		player.mo.state = S_PLAY_PAIN
		player.pflags = $ | PF_FULLSTASIS
		player.mo.flags = $ |MF_BOUNCE
	end
	if player.divingreal == true
	and P_IsObjectOnGround(player.mo)
	or player.playerstate == PST_DEAD
		player.divingreal = false
		player.pflags = $ & ~PF_FULLSTASIS
		player.pflags = $|PF_SPINNING
		player.mo.flags = $ & ~MF_BOUNCE
		player.mo.state = S_PLAY_ROLL
	end
	if player.spindown == nil
		player.spindown = 0
	end
	if not (player.cmd.buttons & BT_SPIN)
		player.spindown = 0
	end
	if player.cmd.buttons & BT_SPIN
	and player.mo.skin == "jett"
	and player.mo.state ~= S_PLAY_PAIN
	and player.spindown == 0
	and not (player.pflags & PF_SPINNING)
	and P_IsObjectOnGround(player.mo)
		S_StartSound(player.mo, sfx_zoom)
		player.mo.state = S_PLAY_PAIN
		player.pflags = $|PF_SPINNING
		P_InstaThrust(player.mo, player.mo.angle, 55*FRACUNIT)
		player.spindown = 1
	end
	if player.pflags & PF_SPINNING
	and player.mo.skin == "jett"
		local slidedust = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, 0, MT_SPINDUST)
		slidedust.momx = P_RandomRange(-4, 4)*FRACUNIT
		slidedust.momy = P_RandomRange(-4, 4)*FRACUNIT
		slidedust.momz = P_RandomRange(0, 4)*FRACUNIT
		slidedust.destscale = -1
		player.mo.state = S_PLAY_PAIN
	end
	if not (S_SoundPlaying(player.mo,sfx_s3k7e))
	and player.pflags & PF_SPINNING
	and player.mo.skin == "jett" then
		S_StartSound(player.mo, sfx_s3k7e)
	end
	if player.pflags & PF_SPINNING
	and not P_IsObjectOnGround(player.mo)
	and player.mo.skin == "jett"
		player.mo.state = S_PLAY_SPRING
		player.pflags = $ & ~PF_SPINNING
	end
end)

addHook("AbilitySpecial", function(player)
	if player.mo.skin == "jett"
	and (player.pflags & PF_JUMPED)
	and not (player.pflags & PF_THOKKED)
	and not (player.mo.state == S_PLAY_PAIN)
		P_SetObjectMomZ(player.mo, 5*FRACUNIT)
		P_InstaThrust(player.mo, player.mo.angle, player.speed)
		S_StartSound(player.mo, sfx_s3kae)
		player.divingreal = true
	end
end)